/* $Id: listfct.pl,v 1.1 1995/11/29 16:00:57 uwe Exp $ */

/* simple list processing ------------------------------------------------------*/

append(X,Y,Z,R) :-
	append(Y,Z,R1),
	append(X,R1,R).

remove(_,[],[]) :-
        !.
remove(E,[E|T],R) :-
        !,
        remove(E,T,R).
remove(E,[H|T],[H|R]) :-
        remove(E,T,R).

remove_duplicates([],[]).
remove_duplicates([H|T],[H|R]) :-
        remove_duplicates(T,R1),
        remove(H,R1,R).

sublist([],[]).
sublist([],[_|_]).
sublist([H1|T1],[H1|T2]) :-
        !,
        sublist(T1,T2).
sublist(L,[_|R]) :-
        sublist(L,R).

			/* distributed conactenation */
concate([],[]).
concate([L],L).
concate([L1,L2|R],LR) :-
	concate([L2|R],L),
	append(L1,L,LR).

/*------------------------------------------------------------------------------*/
