% $Id: mug11.pl,v 1.1 1995/11/29 16:01:00 uwe Exp $ 
% Tiefensuche mit zufaelliger Auswahl der Regeln 
% --> Erfolg auch zufaellig    

:-op(200,xfx,:).

rule(1, X:Y, 4:Y) :- 
	X < 4.
rule(2, X:Y, X:3) :- 
	Y < 3.
rule(3, X:Y, 0:Y) :- 
	X > 0.
rule(4, X:Y, X:0) :- 
	Y > 0.
rule(5, X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4.
rule(6, X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3.
rule(7, X:Y, Z:0) :-
	Y > 0, X + Y < 4, 
	Z is X + Y.
rule(8, X:Y, 0:Z) :-
	X > 0, X + Y < 3, 
	Z is X + Y.
    
    % a) Loesung gefunden: stop 
trans(S0,Sn) :-
     S0 = Sn,
     !, write('Loesung gefunden'),nl.

    % b) Regel waehlen und probieren 
trans(S0,Sn) :-
        choose(N),
        write('('),write(N),write(')'),
        rule(N,S0,S1),
        write(' --> '),write(S1),nl,
        trans(S1,Sn).
        
    % c) Regel N nicht anwendbar : weitermachen
trans(S0,Sn) :-
     trans(S0,Sn).
  
choose(X) :- random(8,X).

:- assert(seed(13)).

random(R,N) :-
	retract(seed(S)),
	N is ((S // 11) mod R) + 1,
	NewSeed is (897 * S + 2111) mod 12345,
	asserta(seed(NewSeed)),
	!.

zweiliter :- trans(0:0, 2:_).
