/* $Id: trace.pl,v 1.1 1995/11/29 16:01:05 uwe Exp $ */
/* trace output praedikate traceon traceoff und traceout
   fuer optionalen trace output
*/

:- assertz(
	(help :-	
		write('Testoutput kann eingeschaltet werden mit traceon/0'), nl,
		write('ausschalten mit traceoff/0'), nl,
		nl, fail)
	).

:- assert(traceflag(off)).

traceon :-
	retractall(traceflag(_)),
	assert(traceflag(on)).
traceoff :-
	retractall(traceflag(_)),
	assert(traceflag(off)).

traceout(_) :-
	traceflag(off),
	!.

traceout(Predicate) :-
	traceflag(on),
	call(Predicate).
	
