% $Id: krug-astern.pl,v 1.1 1995/11/29 16:00:56 uwe Exp $ 

%--- Wasserkrugproblem mit A*-Algorithmus -------------- -----------------------------

:- asserta(
	(help :-
		write('Wasserkrugproblem mit A*-Algorithmus'), nl,
		write('Ziele:'), nl,
		write('   zweiliter(MaximaleAnzahlSchritte).'), nl,
		write('   zweiliter. (zweiliter(100))'), nl,
		write('   ziel.	-> Suche mit verschiedenen Kostenfunktionen'), nl,
		nl, fail)
	).

:- consult('astern').
:- consult('krug-regeln').
:- consult('krug-kosten').

:- traceon.

:- assertz((help :- true)).
:- help.

%--- tests ---------------------------------------------------------------------------

zweiliter(Max) :- 
	solve(0:0,Max).

zweiliter :-
	zweiliter(100).

ziel :-
	write('breitensuche'), nl, breitensuche, zweiliter,
	write('bestensuche'),  nl, bestensuche,  zweiliter,
	write('wasserkosten'), nl, wasserkosten, zweiliter,
	write('bestensuche1'), nl, bestensuche1, zweiliter.

%-------------------------------------------------------------------------------------
