% $Id: krug-breit.pl,v 1.1 1995/11/29 16:00:56 uwe Exp $ 

%--- Wasserkrugproblem mit Breitensuche in einem Graphen -----------------------------

:- asserta(
	(help :-
		write('Wasserkrugproblem mit Breitensuche'), nl,
		write('Ziele:'), nl,
		write('   zweiliter(MaximaleSuchtiefe).'), nl,
		write('   zweiliter. (Suchtiefe 7)'), nl,
		nl, fail)
	).

:- assertz((help :- true)).

:- consult('breitensuche').
:- consult('krug-regeln').

:- help.

%--- tests ---------------------------------------------------------------------------

zweiliter(Max) :- 
	solve(0:0,Max).

zweiliter :-
         zweiliter(7).

ziel :-
	zweiliter.

%-------------------------------------------------------------------------------------

