% $Id: medizin-astern.pl,v 1.1 1995/11/29 16:00:58 uwe Exp $ 

:- asserta(
	(help :-
		write('Medizin mischen durch A*-Algorithmus'), nl,
		write('Ziele:'), nl,
		write('   zweiliter(MaximaleAnzahlSchritte).'),nl,
		write('   zweiliter. (zweiliter(200))'), nl,
                write('   ziel. -> Suche mit verschiedenen Kostenfunktionen'), nl,
		nl, fail)
	).

:- op(700, xfx, [ :=, gr, ge, eq ] ).
:- op(990,xfx,:).

:- consult('astern').
:- consult('medizin-regeln').
:- consult('medizin-kosten').

:- traceon.

:- assertz((help :- true)).
:- help.

zweiliter(I) :- solve(2+0:0+0,I).
          
zweiliter :-
	zweiliter(200).

ziel :-
        write('breitensuche'), nl, breitensuche, zweiliter,
        write('wasserkosten'), nl, wasserkosten, zweiliter,
        write('bestensuche'),  nl, bestensuche,  zweiliter.

