% $Id: mug2.pl,v 1.1 1995/11/29 16:01:00 uwe Exp $ 
% Tiefensuche mit Begrenzung der Tiefe 
% bis Tiefe <= 6 : keine Loesung       
% ab  Tiefe >= 7 : Loesung             
% ohne Erklaerungskomponente           

:-op(200,xfx,:).
  
rule(X:Y, 4:Y) :- 
	X < 4,
		write('Krug4 fuellen'),nl.
rule(X:Y, X:3) :- 
	Y < 3,
		write('Krug3 fuellen'),nl.
rule(X:Y, 0:Y) :- 
	X > 0,
		write('Krug4 leeren'),nl.
rule(X:Y, X:0) :- 
	Y > 0,
		write('Krug3 leeren'),nl.
rule(X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4,
		write('Krug3 teilweise --> Krug4'),nl.
rule(X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3,
		write('Krug4 teilweise --> Krug3'),nl.
rule(X:Y, Z:0) :- 
	Y > 0, X + Y < 4, 
	Z is X + Y,
		write('Krug3 ganz --> Krug4'),nl.
rule(X:Y, 0:Z) :- 
	X > 0, X + Y < 3, 
	Z is X + Y,
		write('Krug4 ganz --> Krug3'),nl.
    
trans(S0,Sn,_,_) :- 
	S0 = Sn, 
	write('  Loesung gefunden'),nl, 
	!.
trans(_,_,Max,Max) :- 
	write('  Sackgasse'),nl, 
	!,fail.
trans(S0,Sn,N,Max) :- 
	N1 is N + 1,
	rule(S0,S1),
	trans(S1,Sn,N1,Max).
 
zweiliter(Max) :- 
	trans(0:0, 2:_, 0, Max).

zweiliter :-
	zweiliter(7).

