% $Id: puzzle9-astern.pl,v 1.1 1995/11/29 16:01:03 uwe Exp $ 

% 9 - Puzzle mit A* --------- --------------------------------------------------------

:- asserta(
	(help :-
		write('Das 9-Puzzle mit dem A*-Algorithmus '), nl,
		write('Die 3x3 Matrix wird zeilenweise durchnummeriert'), nl,
		write('Das - Zeichen fungiert als Loch'), nl,
		write('Tests:'), nl,
		write('   ziel(1). bis ziel(4).'),nl,
		write('   ziel(1) sehr einfach, ... '), nl,
                write('   ziel(4) --> stack overflow'), nl,
		write('   ziel.   --> ziel(1) bis ziel(4) mit verschiedenen Strategien.'), nl,
		nl, fail)
	).

:- consult('astern').
:- consult('puzzle9-regeln').
:- consult('puzzle9-kosten').

:- traceon.

:- assertz((help :- true)).
:- help.

%--- tests ---------------------------------------------------------------------------

ziel(1) :-
	solve(8+[1,2,3,4,5,6,7,'-',8],100).
ziel(2) :-
	solve(1+['-',2,3,1,5,6,4,7,8],100).         
ziel(3) :-
	solve(6+[2,3,5,1,4,'-',7,8,6],100).
                                                      /* ziel(4) besitzt keine Loesung */
ziel(4) :-
	solve(6+[3,2,5,1,4,'-',7,8,6],200).

ziel123 :-
	ziel(1),ziel(2),ziel(3).

ziel :-
        write('breitensuche'), nl, breitensuche, ziel123,
        write('bestensuche'),  nl, bestensuche,  ziel123,
        write('bestensuche1'), nl, bestensuche1, ziel123,
        write('kurzewege'),    nl, kurzewege,    ziel123.
 
	
%-------------------------------------------------------------------------------------
