% $Id: puzzle9-breit.pl,v 1.2 1996/12/12 07:55:20 uwe Exp $ 

% 9 - Puzzle mit Breitensuche --------------------------------------------------------

:- asserta(
	(help :-
		write('Das 9-Puzzle mit Breitensuche '), nl,
		write('Die 3x3 Matrix wird zeilenweise durchnummeriert'), nl,
		write('Das - Zeichen fungiert als Loch'), nl,
		write('Tests:'), nl,
		write('   ziel(1). bis ziel(4).'),nl,
		write('   ziel(1) sehr einfach, ... '), nl,
                write('   ziel(4) --> stack overflow'), nl,
		nl, fail)
	).

:- consult('breitensuche').
:- consult('puzzle9-regeln').

:- traceon.

:- assertz((help :- true)).
:- help.

%--- tests ---------------------------------------------------------------------------

ziel(1) :-
	solve(8+[1,2,3,4,5,6,7,'-',8],10).
ziel(2) :-
	solve(1+['-',2,3,1,5,6,4,7,8],10).         
ziel(3) :-
	solve(6+[2,3,5,1,4,'-',7,8,6],10).
ziel(4) :-
	solve(6+[3,2,5,1,4,'-',7,8,6],20).

ziel :-
	ziel(1),
	ziel(2),
	ziel(3),
	ziel(4).

%-------------------------------------------------------------------------------------
